# Kapitel 10 - Lösungen

from math import *

# Aufgabe 1

def ggT(a,b):
    if b==0: return a
    return ggT(b, a%b)

def Bruch(z,n):
    z=int(z)
    n=int(n)
    t=ggT(z,n)
    return [z/t,n/t]

def Z(bruch): return bruch[0]
def N(bruch): return bruch[1]

def printBruch(bruch): print(bruch2str(bruch))
def bruch2str(bruch): return "("+str(int(Z(bruch)))+"/"+str(int(N(bruch)))+")"

def add(a,b): return Bruch(Z(a)*N(b)+Z(b)*N(a),N(a)*N(b))
def sub(a,b): return Bruch(Z(a)*N(b)-Z(b)*N(a),N(a)*N(b))
def mul(a,b): return Bruch(Z(a)*Z(b),N(a)*N(b))
def div(a,b): return Bruch(Z(a)*N(b),N(a)*Z(b))



a=Bruch(7,12)
b=Bruch(19,14)
print(bruch2str(a),"+",bruch2str(b),"=",bruch2str(add(a,b)))
print(bruch2str(a),"*",bruch2str(b),"=",bruch2str(mul(a,b)))
print(bruch2str(a),":",bruch2str(b),"=",bruch2str(div(a,b)))

# Aufgabe 2

def polyStr(p):
    s=""
    for i in range(len(p)):
        s=s+str(p[-i-1])+"*x^"+str(len(p)-i-1)
        if i<len(p)-1: s=s+"+"
    return s

def bereinige(p): # Entfernt Nullen am Ende
    if p==[]: return p
    if p[-1]==0 or p[-1]==0.0: return bereinige(p[:-1])
    return p

def polyAdd(p,q):
    if len(p)<len(q): p=p+[0]*(len(q)-len(p))
    if len(p)>len(q): q=q+[0]*(len(p)-len(q))
    return bereinige([p[i]+q[i] for i in range(len(p))])
def polySub(p,q):
    if len(p)<len(q): p=p+[0]*(len(q)-len(p))
    if len(p)>len(q): q=q+[0]*(len(p)-len(q))
    return bereinige([p[i]-q[i] for i in range(len(p))])
def polyMulZahl(s,p):
    return [s*p[i] for i in range(len(p))]
def polyMul(p,q):
    res=[0]*(len(p)+len(q)-1)
    for i in range(len(p)):
        for j in range(len(q)):
            res[i+j]+=p[i]*q[j]
    return res
def polyDiv(p,q):
    quotient=[]
    while True:
        if len(p)<len(q): return [quotient,p] # Quotient 0 Rest p
        qu=[0]*(len(p)-len(q)+1)
        qu[-1]=p[-1]/q[-1]
        p=polySub(p,polyMul(qu,q))
        quotient=polyAdd(quotient,qu)

p=[5,3,2,6,8]
q=[9,-4,2]
print("p=",polyStr(p))
print("q=",polyStr(q))
print("p+q=",polyStr(polyAdd(p,q)))
print("p*q=",polyStr(polyMul(p,q)))
print("p:q=",polyStr(polyDiv(p,q)[0]), "Rest=",polyStr(polyDiv(p,q)[1]))



# Aufgabe 3

print()

def vadd(a,b): return [ x+y for (x,y) in zip(a,b) ]
def vsub(a,b): return [ x-y for (x,y) in zip(a,b) ]
def smul(s,a): return [ s*x for x in a ]
def skalarProdukt(a,b): return sum([ x*y for (x,y) in zip(a,b) ])
def norm(v): return sqrt(skalarProdukt(v,v))
def kreuzProdukt(a,b): return [a[1]*b[2]-a[2]*b[1],-(a[0]*b[2]-a[2]*b[0]), a[0]*b[1]-a[1]*b[0]] 
def schnittGE(A,u,nv,d):# Schnitt der Geraden A+t*u mit Ebene x.nv=d
    # (A+t*u).nv=d  A.nv+t*u.nv=d
    t=(d-skalarProdukt(A,nv))/skalarProdukt(u,nv)
    return vadd(A,smul(t,u))
def abstandPP(P,Q): return norm(vsub(P,Q))
def abstandPE(P,nv,d): # Abstand zur Ebene nv.x=d
    return abstandPP(P,projeziere(P,nv,d))
def abstandPG(P,A,u): # Abstand von P von der Geradet A+t*u
    # (P-A-t*u).u=0 d.h. (P-A).u-t*u.u=0, d.h. t=(P-A).u/norm(u)^2
    t=skalarProdukt(vsub(P,A),u)/norm(u)**2
    return abstandPP(P,vadd(A,smul(t,u)))
def projeziere(P,nv,d): # Projeziere P auf die Ebene nv.x=d
    s=(d-skalarProdukt(nv,P))/norm(nv)**2 # (P+s*nv).nv=d nach s aufgelöst
    return vadd(P,smul(s,nv))
def HesseForm(U,u,v): # Hesse-Form aus Aufpunkt und Richtungsvektoren
    n=kreuzProdukt(u,v)
    n=smul(1/norm(n),n) # Einheitsvektor
    return [n,skalarProdukt(n,U)]
def abstandGG(A,u,B,v): # Geraden A+s*u, B+t*v
    k=kreuzProdukt(u,v)
    [n,d]=HesseForm(A,u,k)
    S=schnittGE(B,v,n,d)
    return abstandPG(S,A,u)
    
print("Schnitt der Geraden [1,1,1]+t*[2,0,0] mit der Ebene [1,1,1].x=10 ist:",
      schnittGE([1,1,1],[2,0,0],[1,1,1],10))
print("Projektion von [1,0,0] auf die  Ebene [1,1,1].x=10 ist:",
      projeziere([1,0,0],[1,1,1],10))
[n,d]=HesseForm([1,2,3],[8,1,1],[2,0,0])
print("HesseForm der Ebene [1,2,3]+t*[8,1,1]+u*[2,0,0] ist ",n,".x=",d)
print("Abstand von [1,1,1] von [2,0,0]+t*[1,0,0] ist",
      abstandPG([1,1,1],[2,0,0],[1,0,0]))
print("Abstand von [1,1,1]+u*[3,2,1] von [2,0,0]+t*[1,0,0] ist",
      abstandGG([1,1,1],[3,2,1],[2,0,0],[1,0,0]))



# Aufgabe 4

def submatrix(M,i,j): # Matrix mit Zeile i und Spalte j entfernt
    A=M[:i]+M[i+1:]
    return [ZeileOhneI(zeile,j) for zeile in A]
def ZeileOhneI(zeile,i): return zeile[:i]+zeile[i+1:]

def determinante(M):
    n=len(M)
    if n==1: return M[0][0]
    if n==2: return M[0][0]*M[1][1]-M[1][0]*M[0][1]
    det=0
    for i in range(n):
        det+=(-1)**i*M[i][0]*determinante(submatrix(M,i,0))
    return det

print()
M=[[1,2,3],[8,1,0],[0,2,2]]
print("Determinante von M ist ",determinante(M))

# Nullstellensuche aus Kapiel 8
def nullAuto(f,a,b):
    n=1000 # Zahl der Probestellen
    nullst=[]
    xalt=a
    for i in range(1,n):
        x=a+(b-a)/n*i
        if f(x)*f(xalt)<=0: # Vorzeichenwechsel gefunden
            nullst.append(bisekt(f,xalt,x))
        if abs(f(a))<0.1: # auffaellig kleiner Wert:
            nullst.append(newton(f,x))
        xalt=x
    return nullst
def ableitung(f,x):
    h=0.00001
    return (f(x+h)-f(x))/h
def newton(f,x0):
    while abs(f(x0))>1e-15: x0+=-f(x0)/ableitung(f,x0)
    return x0
def bisekt(f,a,b):
    if f(a)*f(b)>0:
        print("Vorzeichen an beiden Stellen gleich - keine Lösung")
        return
    while b-a>0.00001:
        m=(a+b)/2
        if f(m)*f(a)<=0: # Vorzeichenwechsel zwischen a und m
            b=m          # Neues Intervall a..m
        if f(m)*f(b)<=0: # Vorzeichenwechsel zwischen b und m
            a=m
    return (a+b)/2

# Weiter mit Eigenwerten

def eigenwerte(M):
    def charPoly(t):
        n=len(M)
        A=[[M[i][j] for i in range(n)] for j in range(n)]
        for i in range(n): A[i][i]=A[i][i]-t
        return determinante(A)   
    return nullAuto(charPoly,-1000,1000)

print("Eigenwerte von M sind ", eigenwerte(M))


# Aufgabe 5 : Intervallarithmetik:

def iadd(A,B): return  [A[0]+B[0],A[1]+B[1]]
def isub(A,B): return  iadd(A,iminus(B))
def iminus(A): return [-A[1],-A[0]]
def imult(A,B):  
    [a,b]=A
    [c,d]=B
    return [min (a*c, a*d, b*c, b*d), max (a*c, a*d, b*c, b*d)]
def iinv(A): return [1.0/A[1],1.0/A[0]]
def idiv(A,B): return imult(A,iinv(B))
def isqr(A): return imult(A,A)
def isin(x,A): return A[0]<=x and x <=A[1]

a=[2,2.01]
b=[8,8.01]
print("Intervallarithmetik: ",a,"*",b,"=",imult(a,b))
print("Intervallarithmetik: ",b,"/",a,"=",idiv(b,a))


def Heron(A,x=[]):
    if x==[]: x=A
    c=10
    while c>0:
        c=c-1
        print(x)
        x=smul(0.5,iadd(x,idiv(A,x)))
        if isin(0,isub(A,isqr(x))): return x
    return x
print()
print("Beispiel zu Heron mit Intervallarithmetik: Eingangsfehler werden gross")
print("Heron mit Startintervall [3.9999,4.0001] liefert ",Heron([3.9999,4.0001]))
