# Kapitel 14 - Clusteranalyse - Lösungen 
# Nur minimale Änderungen nötig ggenüber Kapiteldateien

from random import *
from math import *

BeispielDaten=[[9,2,3],[9,9,9],[7,0,5],[8,4,4],
               [9,3,2],[7,9,8],[5,1,1],[7,2,3]]

def Mitelpunktvon(daten):
    dim=len(daten[0]) # Dimension der einzelnen Punkte/Vektoren
    ergebnis=[0]*dim
    for i in range(dim): # fuer jede Dimension
        for punkt in daten: # werden die Eintraege aller Daten addiert
            ergebnis[i]+=punkt[i]
    return [x/len(daten) for x in ergebnis]

#def abstand(p,q): return sqrt(sum([(p[i]-q[i])**2 for i in range(len(p))]))
def abstand(p,q): return 1-korrel(p,q)
def korrel(a,b):
    ma=sum(a)/len(a)   # Mittelwerte berechnen und abziehen
    mb=sum(b)/len(b)
    a=[x-ma for x in a]
    b=[y-mb for y in b]
    va=sum([x**2 for x in a]) # Varianzen berechnen und dividieren
    vb=sum([y**2 for y in b])
    if va>0: a=[x/sqrt(va) for x in a]
    if vb>0: b=[y/sqrt(vb) for y in b]
    return sum([a[i]*b[i] for i in range(len(a))])
               
def kCluster(daten,k):
    n=len(daten)
    clusterVon=[i%k for i in range(n)] # i-tes Datum gehoert zu diesem Cluster
    def punkteVonCluster(j): # j ist Cluster-Nummer
        return [daten[i] for i in range(n) if clusterVon[i]==j]
    esAendertsichWas=True
    while esAendertsichWas:
        esAendertsichWas=False 
        zentren=[Mitelpunktvon(punkteVonCluster(j)) for j in range(k)]
        for i in range(n):
            punkt=daten[i]
            optimal=0 # Das wird die Nummer des besten zentrums
            for c in range(1,k):
                if abstand(zentren[c],punkt)<abstand(zentren[optimal],punkt):
                    optimal=c
            if not(clusterVon[i]==optimal): esAendertsichWas=True
            clusterVon[i]=optimal
    return [punkteVonCluster(j) for j in range(k)]

    
def clusterFehler(daten,clusters):
    fehlersumme=0
    for c in clusters:
        m=Mitelpunktvon(c)
        for p in c: fehlersumme+=abstand(p,m)
    return fehlersumme

for k in range(1,5):
    print("Analyse mit ",k," Clustern")
    clusters=kCluster(BeispielDaten,k)
    print("Fehlersumme=",clusterFehler(BeispielDaten,clusters))
    print()

    
# Hierachiche Clusteranalyse

# das Folgende Bestimmt den Mittelpunkt von Vektoren aus verschachtelten Listen
def Schwerpunkt(daten): return Mitelpunktvon(flach(daten))
def istVektor(L): return type(L)==list and (type(L[0])==int or type(L[0])==float)
def flach(L):
    if istVektor(L): return [L] 
    Lflach=[flach(u) for u in L]
    ergebnis=[]
    for liste in Lflach: ergebnis=ergebnis+liste
    return ergebnis

def hcluster(daten):
    C=[p for p in daten] # Eine Kopie der Daten - liefert Cluster
    while len(C)>1:
        optimalespaar=[0,1]
        optimalerAbstand=abstand(Schwerpunkt(C[0]),Schwerpunkt(C[1]))
        for i in range(len(C)-1):
            for j in range(i+1,len(C)):
                if abstand(Schwerpunkt(C[i]),Schwerpunkt(C[j]))<optimalerAbstand:
                    optimalespaar=[i,j]
                    optimalerAbstand=abstand(Schwerpunkt(C[i]),Schwerpunkt(C[j]))
        [r,s]=optimalespaar
        C=C[:r]+C[r+1:s]+C[s+1:]+[[C[r],C[s]]]
    return C[0]

print("hcluster",hcluster(BeispielDaten))


def printCluster(C,tiefe=0):
    if istVektor(C):
        print((" "*tiefe)+str(C))
        return
    print((" "*(tiefe-1))+"[")
    for c in C:
        printCluster(c,tiefe+5)
    print((" "*(tiefe-1))+"]")

print("----")
printCluster(hcluster(BeispielDaten))

    
