# Kapitel 8 - Lösungen

from math import *

# Aufgabe 1 

def ableit2(f,x):
    h=0.0000001
    d1=(f(x)-f(x-h))/h  # 1. Ableitung zwischen x-h und x
    d2=(f(x+h)-f(x))/h  # 1. Ableitung zwischen x und x+h
    return (d2-d1)/h # 2. Ableitung ist die Ableitung der Ableitung

print("sin''(0)=",ableit2(sin,0))
print("sin''(pi/2)=",ableit2(sin,pi/2))

# Jetzt Ableitung als Funktion erzeugen:

def D2(f):
    def abl2(x):
        h=0.0000001
        d1=(f(x)-f(x-h))/h  # 1. Ableitung zwischen x-h und x
        d2=(f(x+h)-f(x))/h  # 1. Ableitung zwischen x und x+h
        return (d2-d1)/h # 2. Ableitung ist die Ableitung der Ableitung
    return abl2

sin2=D2(sin)
print("Nochmal: ")
print("sin''(0)=",sin2(0))
print("sin''(pi/2)=",sin2(pi/2))
print()

def ableitung(f,x): # Aus Kapitel 8
    h=0.00001
    return (f(x+h)-f(x))/h
def newton(f,x0):
    while abs(f(x0))>1e-15:
        x0+=-f(x0)/ableitung(f,x0)
    return x0

def test(x): return x*(x-1)**2

print("Wendestelle von x*(x-1)**2 möglich bei ",newton(D2(test),1))



# Aufgabe 2

# Aus Kapitel 8:
def nullAuto(f,a,b):
    n=1000 # Zahl der Probestellen
    nullst=[]
    xalt=a
    for i in range(1,n):
        x=a+(b-a)/n*i
        if f(x)*f(xalt)<=0: # Vorzeichenwechsel gefunden
            nullst.append(bisekt(f,xalt,x))
        if abs(f(a))<0.1: # auffaellig kleiner Wert:
            nullst.append(newton(f,x))
        xalt=x
    return nullst
def bisekt(f,a,b):
    if f(a)*f(b)>0:
        print("Vorzeichen an beiden Stellen gleich - keine Lösung")
        return
    while b-a>0.00001:
        m=(a+b)/2
        if f(m)*f(a)<=0: # Vorzeichenwechsel zwischen a und m
            b=m          # Neues Intervall a..m
        if f(m)*f(b)<=0: # Vorzeichenwechsel zwischen b und m
            a=m
    return (a+b)/2


def Kurvendiskussion(f,a=-10,b=10):
    def f1(x): return ableitung(f,x)
    f2=D2(f)
    f3=D2(f1)
    eps=1e-8
    print("Kurvendiskussion im Intervall [",a,", ",b,"]")
    print("Nullstellen: ", nullAuto(f,a,b))
    N1=nullAuto(f1,a,b)
    for x in N1:
        if f2(x)>eps: print("Minimum bei x=",x)
        else:
            if f2(x)<-eps: print("Maximum bei x=",x)
            else: print("Waagrechte Tangente bei x=",x)
    N2=nullAuto(f2,a,b)
    for x in N2:
        if f3(x)>eps: print("Wendepunkt R->L x=",x)
        else:
            if f3(x)<-eps: print("Wendepunkt L->R x=",x)
            else: print("Flachstelle bei x=",x)
    
print()

Kurvendiskussion(sin)



# Aufgabe 3

def unstetig(f,a,b):
    stellen=[]
    n=10000
    M=1000000
    def f1(x): return ableitung(f,x)
    step=(b-a)/n
    x=a
    while x<=b:
        if abs(f1(x))>M: stellen.append(x)
        x+=step
    return stellen


print()
print("Mögliche Unstetigkeitsstellen des Tangens: ",unstetig(tan,-10,10))
print("Mögliche Unstetigkeitsstellen von 1/(2-x): ",unstetig(lambda x: 1/(2-x),-10,10))
print("Mögliche Unstetigkeitsstellen von 1/(x**2): ",
      unstetig(lambda x: 1/(x**2),-10,10))
print("Mögliche Unstetigkeitsstellen von 1/(0.001+x**2): ",
      unstetig(lambda x: 1/(0.001+x**2),-10,10))



    
