# Kapitel 9 - Lösungen

from math import *

# Aufgabe 1 - Lösen von Gleichungssystemen

# Vwerwendung der folgenden n-Dimensionalen Optimierung

def miniparN(f,x0): # x0 ist Liste der Startwerte
    n=len(x0)
    for k in range(50): # 50 Mal ...
        for i in range(n): # ... in jede Dimension eindim minimieren
            def fi(x):
                x0[i]=x
                return f(x0)
            x0[i]=miniparstabil(fi,x0[i])
    return x0
def miniparstabil(f,x0):
    maxiter=100 # Maximal 100 Iterationen
    while maxiter>0:
        maxiter=maxiter-1
        a=0.5*abl2(f,x0)
        if a<0.0001: # keine nach oben geoeffnete Parabel
            abl=abl1(f,x0)
            if abl>0: x1=x0-0.01 # schritt nach links
            else:
                if abl<0: x1=x0+0.01
                else: return x0
        else: # Normaler Iterationsschritt
            b=abl1(f,x0)-x0*abl2(f,x0)
            c=0.5*(x0**2*abl2(f,x0)-2*x0*abl1(f,x0)+2*f(x0))
            x1=-b/(2*a) # Das waere der neue Wert
            x1=x0+(x1-x0)*min(a,1) # Bei kleinem a nicht so weit
        if abs(x1-x0)<0.00000001: return x1
        x0=x1
    # print "miniparstabil Warnung: Maximale Iterationszahl erreicht"
    return x0
def abl1(f,x): # Approximation der ersten Anleitung
    h=0.000001
    return (f(x+h)-f(x))/h
def abl2(f,x): # Approximation der zweiten Anleitung
    h=0.000001
    return (abl1(f,x+h)-abl1(f,x))/h


# Jetzt wird ein Gleichungssystem umgeschrieben und durch Optimierung gelöst

def nsolve(gleichungen,startwert): # Liste von Funktionen, die alle Null sein müssen
    def f(x): return sum([g(x)**2 for g in gleichungen])
    return miniparN(f,startwert)

def kreis(x): return (x[0]-1)**2+x[1]**2-9 # Kreis r=3, MP(1|0)
def parabel(x): return x[1]**2-x[0] # nach rechts geöffnete Normalparabel

print("Schnittpunkt ",nsolve([kreis,parabel],[1,1]))
print("Schnittpunkt ",nsolve([kreis,parabel],[1,-1]))

                      

# Aufgabe 2

def grad(f,x0):
    g=[0]*len(x0) # Das wird der Gradient
    h=0.000001
    f0=f(x0)
    for i in range(len(x0)):
        x0[i]+=h # i-te Variable um h aendern
        g[i]=(f(x0)-f0)/h
        x0[i]+=-h  # i-te Variable zuruecksetzen
    return g

def vbetrag(v): return sqrt(sum([x**2 for x in v]))

def solveSimpel(gList,x):
    maxiter=10000
    daempfung=0.5
    while maxiter>0:
        maxiter+=-1
        for g in gList: #
            gr=grad(g,x) 
            t=-g(x)/vbetrag(gr)**2
            for i in range(len(x)): x[i]+=t*gr[i]*daempfung
    return x

print()
print("Schnittpunkt mit solveSimpel",solveSimpel([kreis,parabel],[1,1]))
print()
    
# Aufgabe 3

def integral(f,a,b,n=100):
	delta=(b-a)/n	# Streifenbreite
	s=0.0				# Summe
	for i in range(n):
		s=s+0.5*(f(a+i*delta)+f(a+(i+1)*delta))*delta
	return s

def sintaylor3(x): return x-x**3/6
def poly3(paras,x): # paras sind die Parameter eines kubischen Polynoms
    [a,b,c,d]=paras
    return a*x**3+b*x**2+c*x+d
def quadratFehler(paras):
    def f(x): return (sin(x)-poly3(paras,x))**2
    return integral(f,0,pi)

optPar=miniparN(quadratFehler,[0,0,0,0])

print("optimal passendes Polynom sin(x)=",optPar[0],"*x³+",optPar[1],"*x²+",optPar[2],"*x+",optPar[3])

for x in range(1,4):
    print("x=",x," sin=",sin(x)," taylor3=",sintaylor3(x)," optPoly=",poly3(optPar,x))
    

